commit 8658a2d35527fa2090ca66f34facd15873755dd3
Author: freddy77 <freddy77>
Date:   Wed Sep 10 11:22:24 2008 +0000

    improve error handling in ODBC

diff --git a/ChangeLog b/ChangeLog
index 61376aa..1a10362 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Wed Sep 10 13:19:53 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsodbc.h src/odbc/odbc.c src/odbc/odbc_util.c:
+	* src/odbc/prepare_query.c src/odbc/sql2tds.c:
+	- move odbc_convert_err_set in odbc_util and reuse it
+	- improve sql2tds error handling
+
 Tue Sep 09 16:53:54 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/sql2tds.c: be coherent about constants
 
@@ -623,4 +629,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2603 2008/09/09 14:54:10 freddy77 Exp $
+$Id: ChangeLog,v 1.2604 2008/09/10 11:22:24 freddy77 Exp $
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index 2cfc74f..e9175ba 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.107 2008/08/18 13:31:26 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.108 2008/09/10 11:22:33 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -505,6 +505,7 @@ SQLSMALLINT odbc_get_concise_c_type(SQLSMALLINT type, SQLSMALLINT interval);
 SQLRETURN odbc_set_concise_c_type(SQLSMALLINT concise_type, struct _drecord *drec, int check_only);
 
 SQLLEN odbc_get_octet_len(int c_type, const struct _drecord *drec);
+void odbc_convert_err_set(struct _sql_errors *errs, TDS_INT err);
 
 /*
  * prepare_query.c
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 7a1d15f..05a52c2 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.491 2008/08/18 13:31:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.492 2008/09/10 11:22:34 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -988,10 +988,10 @@ odbc_build_update_params(TDS_STMT * stmt, unsigned int n_row)
 		curcol->table_namelen = strlen(curcol->table_name);
 
 		switch (sql2tds(stmt, drec_ird, &stmt->ard->records[n], curcol, 1, stmt->ard, n_row)) {
-		case SQL_ERROR:
 		case SQL_NEED_DATA:
-			tds_free_param_results(params);
 			odbc_errs_add(&stmt->errs, "HY001", NULL);
+		case SQL_ERROR:
+			tds_free_param_results(params);
 			return NULL;
 		}
 	}
@@ -3438,32 +3438,6 @@ odbc_process_tokens(TDS_STMT * stmt, unsigned flag)
 	}
 }
 
-static void
-odbc_convert_err_set(struct _sql_errors *errs, TDS_INT err)
-{
-	/*
-	 * TODO we really need a column offset in the _sql_error structure so that caller can 
-	 * invoke SQLGetDiagField to learn which column is failing
-	 */
-	switch (err) {
-	case TDS_CONVERT_NOAVAIL:
-		odbc_errs_add(errs, "HY003", NULL);
-		break;
-	case TDS_CONVERT_SYNTAX:
-		odbc_errs_add(errs, "22018", NULL);
-		break;
-	case TDS_CONVERT_OVERFLOW:
-		odbc_errs_add(errs, "22003", NULL);
-		break;
-	case TDS_CONVERT_FAIL:
-		odbc_errs_add(errs, "07006", NULL);
-		break;
-	case TDS_CONVERT_NOMEM:
-		odbc_errs_add(errs, "HY001", NULL);
-		break;
-	}
-}
-
 /*
  * - handle correctly SQLGetData (for forward cursors accept only row_size == 1
  *   for other types application must use SQLSetPos)
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index f87948b..e29ab6e 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -33,12 +33,13 @@
 #include <assert.h>
 
 #include "tdsodbc.h"
+#include "tdsconvert.h"
 
 #ifdef DMALLOC
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.100 2008/08/18 13:31:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.101 2008/09/10 11:22:35 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -1107,4 +1108,30 @@ odbc_get_octet_len(int c_type, const struct _drecord *drec)
 	return len;
 }
 
+void
+odbc_convert_err_set(struct _sql_errors *errs, TDS_INT err)
+{
+	/*
+	 * TODO we really need a column offset in the _sql_error structure so that caller can
+	 * invoke SQLGetDiagField to learn which column is failing
+	 */
+	switch (err) {
+	case TDS_CONVERT_NOAVAIL:
+		odbc_errs_add(errs, "HY003", NULL);
+		break;
+	case TDS_CONVERT_SYNTAX:
+		odbc_errs_add(errs, "22018", NULL);
+		break;
+	case TDS_CONVERT_OVERFLOW:
+		odbc_errs_add(errs, "22003", NULL);
+		break;
+	case TDS_CONVERT_FAIL:
+		odbc_errs_add(errs, "07006", NULL);
+		break;
+	case TDS_CONVERT_NOMEM:
+		odbc_errs_add(errs, "HY001", NULL);
+		break;
+	}
+}
+
 /** @} */
diff --git a/src/odbc/prepare_query.c b/src/odbc/prepare_query.c
index 9e2be47..da2e8f3 100644
--- a/src/odbc/prepare_query.c
+++ b/src/odbc/prepare_query.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: prepare_query.c,v 1.70 2008/09/04 06:43:48 freddy77 Exp $");
+TDS_RCSID(var, "$Id: prepare_query.c,v 1.71 2008/09/10 11:22:36 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -366,17 +366,8 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 					data[1] = *(char*)DataPtr;
 				    
 					res = tds_convert(dbc->env->tds_ctx, src_type, data, 2, dest_type, &ores);
-					switch(res) {
-					case TDS_CONVERT_FAIL:
-					case TDS_CONVERT_NOAVAIL:
-					case TDS_CONVERT_SYNTAX:
-						odbc_errs_add(&dbc->errs, "07006", NULL); /* Restricted data type attribute violation */
-						return SQL_ERROR;
-					case TDS_CONVERT_NOMEM:
-						odbc_errs_add(&dbc->errs, "HY001", NULL); /* Memory allocation error */
-						return SQL_ERROR;
-					case TDS_CONVERT_OVERFLOW:
-						odbc_errs_add(&dbc->errs, "22003", NULL); /* Numeric value out of range */
+					if (res < 0) {
+						odbc_convert_err_set(&dbc->errs, res);
 						return SQL_ERROR;
 					}
 				    
@@ -394,19 +385,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 
 				res = tds_convert(dbc->env->tds_ctx, src_type, DataPtr+start, len, dest_type, &ores);
 				if (res < 0) {
-					switch(res) {
-					case TDS_CONVERT_FAIL:
-					case TDS_CONVERT_NOAVAIL:
-					case TDS_CONVERT_SYNTAX:
-						odbc_errs_add(&dbc->errs, "07006", NULL); /* Restricted data type attribute violation */
-						break;
-					case TDS_CONVERT_NOMEM:
-						odbc_errs_add(&dbc->errs, "HY001", NULL); /* Memory allocation error */
-						break;
-					case TDS_CONVERT_OVERFLOW:
-						odbc_errs_add(&dbc->errs, "22003", NULL); /* Numeric value out of range */
-						break;
-					}
+					odbc_convert_err_set(&dbc->errs, res);
 					free(extradata);
 					return SQL_ERROR;
 				}
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index af04ae2..82fc484 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -52,7 +52,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.72 2008/09/09 14:54:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.73 2008/09/10 11:22:36 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -152,6 +152,7 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 	/* what type to convert ? */
 	dest_type = odbc_sql_to_server_type(dbc->tds_socket, drec_ipd->sql_desc_concise_type);
 	if (dest_type == TDS_FAIL)
+		/* TODO fill error */
 		return SQL_ERROR;
 	tdsdump_log(TDS_DBG_INFO2, "trace\n");
 
@@ -201,6 +202,7 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 	/* TODO test intervals */
 	src_type = odbc_c_to_server_type(sql_src_type);
 	if (src_type == TDS_FAIL)
+		/* TODO fill error */
 		return SQL_ERROR;
 
 	/* we have no data to convert, just return */
@@ -218,6 +220,7 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 			len = odbc_get_octet_len(sql_src_type, drec_apd);
 			if (len < 0)
 				/* TODO sure ? what happen to upper layer ?? */
+				/* TODO fill error */
 				return SQL_ERROR;
 		}
 		src += len * n_row;
@@ -254,7 +257,7 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 		break;
 	case SQL_DEFAULT_PARAM:
 	case SQL_DATA_AT_EXEC:
-		/* TODO */
+		/* TODO fill error */
 		return SQL_ERROR;
 		break;
 	default:
@@ -267,6 +270,7 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 			case SQL_C_BINARY:
 				break;
 			default:
+				/* TODO fill error */
 				return SQL_ERROR;
 			}
 			len = SQL_LEN_DATA_AT_EXEC(sql_len);
@@ -279,14 +283,17 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 			case SQL_LONGVARBINARY:
 				break;
 			default:
+				/* TODO fill error */
 				return SQL_ERROR;
 			}
 		}
 	}
 
 	/* allocate given space */
-	if (!tds_alloc_param_data(curcol))
+	if (!tds_alloc_param_data(curcol)) {
+		odbc_errs_add(&stmt->errs, "HY001", NULL);
 		return SQL_ERROR;
+	}
 
 	if (need_data) {
 		curcol->column_cur_size = 0;
@@ -403,8 +410,10 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 		break;
 	}
 
-	if (res < 0)
+	if (res < 0) {
+		odbc_convert_err_set(&stmt->errs, res);
 		return SQL_ERROR;
+	}
 
 	curcol->column_cur_size = res;
 

